zsh-users
 help / color / mirror / code / Atom feed
From: "Andrej Borsenkow" <Andrej.Borsenkow@mow.siemens.ru>
To: "Zsh users list" <zsh-users@sunsite.auc.dk>
Subject: RE: Trap and exit
Date: Fri, 27 Oct 2000 17:39:50 +0400	[thread overview]
Message-ID: <000401c0401b$613546b0$21c9ca95@mow.siemens.ru> (raw)
In-Reply-To: <0G330024BBOLZ9@la-la.cambridgesiliconradio.com>



> -----Original Message-----
> From: Peter Stephenson [mailto:pws@csr.com]
> Sent: Friday, October 27, 2000 5:20 PM
> To: Zsh users list
> Subject: Re: Trap and exit
>
>
> > It looks like a bug in Zsh.
> >
> > =============
> > The environment in which the shell executes a trap on EXIT will
> be identical
> > to the environment immediately after the last command executed
> before the tra
> > p
> > on EXIT was taken.
> >
> > The exit status will be n, if specified. Otherwise, the value
> will be the exi
> > t
> > value of the last command executed, or zero if no command was
> executed. When
> > exit is executed in a trap action, the last command is considered
> to be the
> > command that executed immediately preceding the trap action.
>
> From this it looks like the status of the trap is the exit value of the
> exit command --- not of the function.  I'm not sure that's even defined.
> If the exit, unlike the function, completed successfully, you could argue
> that the status should be 0.  However, that's not what we're doing.
>

The `exit value of exit command' is defined in second sentence that was taken
from the description of exit command. This is `n, if specified'. That is, exit
status of command `exit 59' is 59. Actually, this makes sense - it sets $? to
59 and exits shell, leaving it with `exit status of last command'.

Of course, Unix standards are known to use the most obscure wording possible.

> % cat foo
> trap 'echo trap: $?' 0
> false
> exit 59
> % zsh ./foo
> trap: 1
>
> But then, you could argue that the false was the last command before the
> script exited, and is hence the one referred to in this case --- given that
> this is exactly what happens with an implicit exit by falling off the end.
>

The last command executed was `exit' not `false'. So, the above is a bug in
any case - exit status is either 0 or 59 (depending on exit status of exit ...
ough :-)

> To summarise: bleah.
>

Well, it adds to functionality in any case; and youor example IMHO counts as
bug. sh and ksh scripts do not expect this anyway and won't be broken. But
there are more chances that bash/ash scripts will run properly.

-andrej


  parent reply	other threads:[~2000-10-27 13:40 UTC|newest]

Thread overview: 11+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2000-10-27 10:44 Akim Demaille
2000-10-27 11:37 ` Andrej Borsenkow
2000-10-27 11:49   ` Andrej Borsenkow
2000-10-27 12:47     ` Akim Demaille
2000-10-27 13:05       ` Andrej Borsenkow
2000-10-27 12:46   ` Akim Demaille
2000-10-27 13:06     ` Andrej Borsenkow
2000-10-27 13:19   ` Peter Stephenson
2000-10-27 13:28     ` Akim Demaille
2000-10-27 13:39     ` Andrej Borsenkow [this message]
2000-10-27 15:26       ` Bart Schaefer

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to='000401c0401b$613546b0$21c9ca95@mow.siemens.ru' \
    --to=andrej.borsenkow@mow.siemens.ru \
    --cc=zsh-users@sunsite.auc.dk \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://git.vuxu.org/mirror/zsh/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).